/*
 * Gimbal
 * Copyright (C) 2024 moonleay
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

package net.moonleay.gimbal.client.keybindings

import net.fabricmc.fabric.impl.client.keybinding.KeyBindingRegistryImpl
import net.minecraft.client.MinecraftClient
import net.moonleay.gimbal.client.keybindings.impl.GimbalShortcut

object KeybindingManager {

    private val shortcuts = mutableListOf<GimbalShortcut>()

    /**
     * Register a shortcut. This will also register the keybinding.
     * */
    fun registerShortcut(shortcut: GimbalShortcut) {
        shortcuts.add(shortcut)
        KeyBindingRegistryImpl.registerKeyBinding(shortcut.keyBinding)
    }

    fun onClientTick(client: MinecraftClient){
        // Sadly, this cannot be done without iterating over all shortcuts :madge:
        for (shortcut in shortcuts)
            if (shortcut.keyBinding.wasPressed())
                shortcut.onPressed(client)
    }
}
